ZFunctionsOptions = {}
ZFunctionsEvents = {}

ZFunctionsList = {};
ZFunctionsCount = 0;
ZFunctionsCurrent = 0;

function ZEquip(...)
	-- 12=Ring, 14=Trinket, 17=OffHand
	if select("#", ...) < 1 or UnitExists("npc") then
		return
	end
	local item, search
	local items = {}
	local num = 0
	if select("#", ...) == 1 then
		items[1] = {select(1, ...), 0}
		num = 1
	else
		for i=1, select("#", ...) do
			if type(select(i, ...)) == "string" then
				num = num + 1
				if type(select(i+1, ...) or "") == "number" then
					items[num] = {select(i, ...), select(i+1, ...)}
				else
					items[num] = {select(i, ...), 0}
				end
			end
		end
	end
	if num == 0 then
		return
	end
	for bag=0, 4 do
		for slot=1, GetContainerNumSlots(bag) do
			for i=1, num do
				item = GetContainerItemLink(bag, slot)
				item = string.lower(ZGetItemName(item))
				search = string.lower(items[i][1])
				if string.match(item, search) then
					PickupContainerItem(bag,slot)
					EquipCursorItem(items[i][2])
					if item == search then
						if num == 1 then
							return
						end
						table.remove(items, i)
						num = num - 1
					end
					break
				end
			end
		end
	end
end

function ZGetItemName(item)
	local _, _, name = string.find(item or "", "|h%[(.-)%]|h")
	return name or ""
end

function ZMouseOverLinks()
	local i
	local frame
	if ZMouseOverLinks1 then
		ZPrint("ZMouseOverLinks Disabled")
		i = 1
		frame = getglobal("ChatFrame"..i)
		while frame do
			frame:SetScript("OnHyperlinkEnter", function() end)
			frame:SetScript("OnHyperlinkLeave", function() end)
			i = i + 1
			frame = getglobal("ChatFrame"..i)
		end
		ZMouseOverLinks1 = nil
		ZFunctionsOptions["ZMouseOverLinks"] = nil
	else
		ZPrint("ZMouseOverLinks Enabled")
		i = 1
		frame = getglobal("ChatFrame"..i)
		while frame do
			frame:SetScript("OnHyperlinkEnter", function()
				if string.find(arg1, "item:") or string.find(arg1, "enchant:") then
					GameTooltip:SetOwner(this, "ANCHOR_TOPLEFT",50,0)
					GameTooltip:SetHyperlink(arg1)
				end
			end)
			frame:SetScript("OnHyperlinkLeave", function()
				GameTooltip:Hide()
			end)
			i = i + 1
			frame = getglobal("ChatFrame"..i)
		end
		ZMouseOverLinks1 = 1
		ZFunctionsOptions["ZMouseOverLinks"] = 1
	end
end

function ZCancelBuff(...)
	for i=1, select("#", ...) do
		local buff = select(i, ...)
		CancelPlayerBuff(buff)
	end
end

function ZHasBuff(spell, unit)
	if not spell then return end
	if not unit then
		unit = "player"
	end
	spell = string.lower(spell)
	for i=1, 40 do
		local buff = UnitBuff(unit, i)
		if not buff then break end
		buff = string.lower(buff)
		if buff == spell then
			return i
		end
	end
end

function ZHasDebuff(spell, unit)
	if not spell then return end
	if not unit then
		unit = "target"
	end
	spell = string.lower(spell)
	for i=1, 40 do
		local debuff = UnitDebuff(unit, i)
		if not debuff then break end
		debuff = string.lower(debuff)
		if debuff == spell then
			return i
		end
	end
end

function ZListBuffs()
	for i=1, 40 do
		local buff = UnitBuff("target", i)
		if not buff then break end
		ZPrint(buff)
	end
end

function ZListDebuffs()
	for i=1, 40 do
		local debuff = UnitDebuff("target", i)
		if not debuff then break end
		ZPrint(debuff)
	end
end

ZFunctionsOldSendChatMessage = SendChatMessage;
function SendChatMessage(msg,chan,a,b,c,d,e,f,g)
	if not UnitExists("target") then
		return ZFunctionsOldSendChatMessage(msg,chan,a,b,c,d,e,f,g)
	end
	local C, R, H, L, TT, PVP, S
	if UnitIsPlayer("target") then
		C = UnitClass("target")
	else
		C = UnitCreatureType("target")
	end
	L = UnitLevel("target")
	H = UnitHealth("target") / UnitHealthMax("target")
	H = H * 100
	H = format("%d",H)
	R = UnitRace("target")
	TT = UnitName("targettarget")
	PVP = UnitPVPName("target")
	S = UnitSex("target")
	if C then
		msg = string.gsub(msg,"%%c",C)
	end
	if L then
		msg = string.gsub(msg,"%%l",L)
	end
	if H then
		msg = string.gsub(msg,"%%h",H.."%%")
	end
	if R then
		msg = string.gsub(msg,"%%r",R)
	end
	if TT then
		msg = string.gsub(msg,"%%tt",TT)
	end
	if PVP then
		msg = string.gsub(msg,"%%pvp",PVP)
	end
	if S then
		local sex = {"unknown","male","female"}
		msg = string.gsub(msg,"%%s",sex[S])
	end
	return ZFunctionsOldSendChatMessage(msg,chan,a,b,c,d,e,f,g)
end

function ZTellMats(name)
	if not name then return end
	local chat
	if type(name) == "number" or tonumber(name) then
		chat = "channel"
	elseif type(name) == "string" then
		name = string.lower(name)
		if name == "guild" or name == "raid" or name == "party" or name == "yell" then
			chat = name
		else
			chat = "whisper"
		end

	else
		return
	end
	local msg
	if TradeSkillFrame and TradeSkillFrame:IsVisible() then
		msg = ZGetTradeSkillMats()
	elseif CraftFrame and CraftFrame:IsVisible() then
		msg = ZGetCraftSkillMats()
	else
		return
	end
	SendChatMessage(msg, chat, nil, name)
end

function ZGetCraftSkillMats()
	if not CraftFrame or not CraftFrame:IsVisible() then
		return
	end
	local item, count
	local msg = ""
	local i = GetCraftSelectionIndex()
	for i2=1, GetCraftNumReagents(i) do
		item, _, count = GetCraftReagentInfo(i,i2)
		msg = msg..", "..item.."("..count..")"
	end
	msg = GetCraftItemLink(i).." = "..strsub(msg, 3)
	return msg
end

function ZGetTradeSkillMats()
	if not TradeSkillFrame or not TradeSkillFrame:IsVisible() then
		return
	end
	local item, count
	local msg = ""
	local i = GetTradeSkillSelectionIndex()
	for i2=1, GetTradeSkillNumReagents(i) do
		item, _, count = GetTradeSkillReagentInfo(i,i2)
		msg = msg..", "..item.."("..count..")"
	end
	msg = GetTradeSkillItemLink(i).." = "..strsub(msg, 3)
	return msg
end

function ZPrint(msg, r, g, b, frame, id)
	if not r then r = 0.0 end
	if not g then g = 1.0 end
	if not b then b = 1.0 end
	if not frame then frame = DEFAULT_CHAT_FRAME end
	if frame then
		frame:AddMessage(msg,r,g,b,id)
	end
end

function ZTellTarget(msg)
	if UnitIsPlayer("target") then
		SendChatMessage(msg, "whisper", nil, UnitName("target"))
	end
end

function ZTellAllWho(text)
	if not text then
		return
	end
	for i=1, GetNumWhoResults() do SendChatMessage(text, "whisper", nil, GetWhoInfo(i)) end
end

function ZRandomEmote()
	DoEmote( getglobal("EMOTE" ..random(170).. "_TOKEN") )
end

function ZReadyCheckAlert()
	if not ZReadyCheckAlert1 then
		ZPrint("ZReadyCheckAlert Enabled")
		ZReadyCheckAlert1 = 1
		ZFunctionsOptions["ZReadyCheckAlert"] = 1
		ZReadyCheckAlertFrame = CreateFrame("frame")
		ZReadyCheckAlertFrame:SetScript("OnShow", function()
			this.z = GetTime()
		end)
		ZReadyCheckAlertFrame:SetScript("OnHide", function()
			this.z = nil
		end)
		ZReadyCheckAlertFrame:SetScript("OnUpdate", function()
			if this.z and GetTime()-this.z > 10 then
				this.z = nil
				RestartGx()
				PlaySound("levelup")
			end
		end)
		if ReadyCheckFrame then
			ZReadyCheckAlertFrame:SetParent(ReadyCheckFrame)
		else
			ZReadyCheckAlertFrame:RegisterEvent("RAID_ROSTER_UPDATE")
			ZReadyCheckAlertFrame:SetScript("OnEvent", function()
				ZReadyCheckAlertFrame:SetParent(ReadyCheckFrame)
				ZReadyCheckAlertFrame:UnregisterAllEvents()
			end)
		end
	else
		ZPrint("ZReadyCheckAlert Disabled")
		ZReadyCheckAlert1 = nil
		ZFunctionsOptions["ZReadyCheckAlert"] = nil
		ZReadyCheckAlertFrame:SetScript("OnUpdate", nil)
	end
end

function ZAltClickTrading()
	if ZAltClickTrading1 then
		ZAltClickTrading1 = nil
		ZFunctionsOptions["ZAltClickTrading"] = false
		ZPrint("ZAltClickTrading Disabled")
	else
		ZAltClickTrading1 = 1
		ZFunctionsOptions["ZAltClickTrading"] = true
		ZPrint("ZAltClickTrading Enabled")
	end
end

function ZAltClickTrading_Click()
	if ZFunctionsOptions["ZAltClickTrading"] and UnitIsPlayer("NPC") and IsAltKeyDown() then
		PickupContainerItem(this:GetParent():GetID(), this:GetID())
		DropItemOnUnit("NPC")
	end
end
hooksecurefunc("ContainerFrameItemButton_OnModifiedClick", ZAltClickTrading_Click)

function ZToggleNames()
	SetCVar("UnitNamePlayer", abs(GetCVar("UnitNamePlayer")-1))
end

function ZToggleTrade()
	SetCVar("BlockTrades", abs(GetCVar("BlockTrades")-1))
end

function ZCheckRaidSpacing()
	if ZOrgAutoFollow then
		AutoFollowStatus:SetScript("OnUpdate",ZOrgAutoFollow)
		AutoFollowStatus:SetScript("OnHide",function() end)
		AutoFollowStatusText:SetFont(ZOrgAutoFollowFont, ZOrgAutoFollowSize)
		ZOrgAutoFollow = nil
		return
	end
	ZOrgAutoFollow = AutoFollowStatus:GetScript("OnUpdate")
	ZOrgAutoFollowFont, ZOrgAutoFollowSize = AutoFollowStatusText:GetFont()
	AutoFollowStatusText:SetFont("Fonts\\frizqt__.ttf", 14)
	AutoFollowStatus:SetScript("OnUpdate",function() ZOrgAutoFollow(arg1) AutoFollowStatus:SetAlpha(1) end)
	AutoFollowStatus:SetScript("OnHide",function()
	msg=""
	local count = 0
	for i=1,40 do
		if CheckInteractDistance("raid".. i,3) and not UnitIsDead("raid"..i) and not UnitIsUnit("raid"..i,"player") then
			msg = UnitName("raid"..i).."\n"..msg
			count = count + 1
		end
		if count >= 10 then
			i = 99
		end
	end
	AutoFollowStatus:SetAlpha(1)
	AutoFollowStatus.fadeTime=1
	AutoFollowStatus:Show()
	AutoFollowStatusText:SetText(msg)
	end)
	AutoFollowStatus.fadeTime=2
	AutoFollowStatus:Show()
	AutoFollowStatusText:SetText("")
end

local f = CreateFrame("frame")
f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:SetScript("OnEvent", function(self, event)
	if event == "PLAYER_ENTERING_WORLD" then
		if ZFunctionsOptions["ZMouseOverLinks"] then ZMouseOverLinks() end
		if ZFunctionsOptions["ZReadyCheckAlert"] then ZReadyCheckAlert() end
		if ZFunctionsOptions["ZAltClickTrading"] then ZAltClickTrading() end
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	end
end)